/*#######################################################################################
Erzeugen eines RC Summen Signals 

Copyright (C) 2006 Ulrich Radig

#######################################################################################*/

#include "rc.h"


unsigned char rc_channel_counter = 0;
unsigned int rc_channel_sum;
unsigned char rc_valid;
volatile unsigned char rc_ch[RC_MAX_CHANNEL];

//############################################################################
//Timer Interrupt Service Routine
ISR (TIMER1_OVF_vect)
//############################################################################
{
 rc_valid = 0;
}

//############################################################################
//Timer Interrupt Service Routine
ISR (INT1_vect)
//############################################################################
{
 if (TCNT1 < RC_MIN_VALUE){
    rc_channel_counter = 0;
    rc_valid = 0;
    TCNT1 = 0;
    }
 if (TCNT1 > RC_MAX_VALUE){
    rc_channel_counter = 0;
    rc_valid = 1;
    TCNT1 = 0;
    }  
    else
    {
    if(rc_valid == 1){
    
    //TCNT1 = TIMER_VALUE_MAX - (RC_OFFSET_TIME + (5 * rc_ch[rc_channel_counter]));
    
        rc_ch[rc_channel_counter]= ((TCNT1 - 1000)/5);
        rc_valid = 1; 
        if(rc_channel_counter++ > RC_MAX_CHANNEL){
            rc_valid = 0;
            rc_channel_counter=0;
            }
        TCNT1 = 0;
        }
    }
}

//############################################################################
//Diese Routine startet und inizialisiert den Timer
void rc_sum_init (void)
//############################################################################
{
    //Interrupt for the Clock enable  
    TIMSK |= (1<<TOIE1);
    //Setzen des Prescaler auf 8
    TCCR1B |= (1<<CS11); 
    TCNT1 = TIMER_VALUE_MAX - RC_REPETITION_TIME;
    
    //falling edge generates an interrupt
    MCUCR |= (1<<ISC11);
    //external interrupt 1 enable
    GICR |= (1<<INT1);
    DDRD &= ~(1<<PD3);
    
    return;
}




